package com.hfkj.dao;

import com.hfkj.entity.BsRebateMerAccountRecord;
import com.hfkj.entity.BsRebateMerAccountRecordExample.Criteria;
import com.hfkj.entity.BsRebateMerAccountRecordExample.Criterion;
import com.hfkj.entity.BsRebateMerAccountRecordExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsRebateMerAccountRecordSqlProvider {

    public String countByExample(BsRebateMerAccountRecordExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_rebate_mer_account_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsRebateMerAccountRecordExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_rebate_mer_account_record");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsRebateMerAccountRecord record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_rebate_mer_account_record");
        
        if (record.getAccountId() != null) {
            sql.VALUES("account_id", "#{accountId,jdbcType=BIGINT}");
        }
        
        if (record.getAccountNumber() != null) {
            sql.VALUES("account_number", "#{accountNumber,jdbcType=BIGINT}");
        }
        
        if (record.getTradeType() != null) {
            sql.VALUES("trade_type", "#{tradeType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeNumber() != null) {
            sql.VALUES("trade_number", "#{tradeNumber,jdbcType=VARCHAR}");
        }
        
        if (record.getTradeAmount() != null) {
            sql.VALUES("trade_amount", "#{tradeAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getAmountBeforeChange() != null) {
            sql.VALUES("amount_before_change", "#{amountBeforeChange,jdbcType=DECIMAL}");
        }
        
        if (record.getAmountAfterChange() != null) {
            sql.VALUES("amount_after_change", "#{amountAfterChange,jdbcType=DECIMAL}");
        }
        
        if (record.getObjectType() != null) {
            sql.VALUES("object_type", "#{objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.VALUES("object_id", "#{objectId,jdbcType=BIGINT}");
        }
        
        if (record.getObjectContent() != null) {
            sql.VALUES("object_content", "#{objectContent,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsRebateMerAccountRecordExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("account_id");
        sql.SELECT("account_number");
        sql.SELECT("trade_type");
        sql.SELECT("trade_number");
        sql.SELECT("trade_amount");
        sql.SELECT("amount_before_change");
        sql.SELECT("amount_after_change");
        sql.SELECT("object_type");
        sql.SELECT("object_id");
        sql.SELECT("object_content");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_rebate_mer_account_record");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsRebateMerAccountRecord record = (BsRebateMerAccountRecord) parameter.get("record");
        BsRebateMerAccountRecordExample example = (BsRebateMerAccountRecordExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_rebate_mer_account_record");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getAccountId() != null) {
            sql.SET("account_id = #{record.accountId,jdbcType=BIGINT}");
        }
        
        if (record.getAccountNumber() != null) {
            sql.SET("account_number = #{record.accountNumber,jdbcType=BIGINT}");
        }
        
        if (record.getTradeType() != null) {
            sql.SET("trade_type = #{record.tradeType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeNumber() != null) {
            sql.SET("trade_number = #{record.tradeNumber,jdbcType=VARCHAR}");
        }
        
        if (record.getTradeAmount() != null) {
            sql.SET("trade_amount = #{record.tradeAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getAmountBeforeChange() != null) {
            sql.SET("amount_before_change = #{record.amountBeforeChange,jdbcType=DECIMAL}");
        }
        
        if (record.getAmountAfterChange() != null) {
            sql.SET("amount_after_change = #{record.amountAfterChange,jdbcType=DECIMAL}");
        }
        
        if (record.getObjectType() != null) {
            sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        }
        
        if (record.getObjectContent() != null) {
            sql.SET("object_content = #{record.objectContent,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_rebate_mer_account_record");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("account_id = #{record.accountId,jdbcType=BIGINT}");
        sql.SET("account_number = #{record.accountNumber,jdbcType=BIGINT}");
        sql.SET("trade_type = #{record.tradeType,jdbcType=INTEGER}");
        sql.SET("trade_number = #{record.tradeNumber,jdbcType=VARCHAR}");
        sql.SET("trade_amount = #{record.tradeAmount,jdbcType=DECIMAL}");
        sql.SET("amount_before_change = #{record.amountBeforeChange,jdbcType=DECIMAL}");
        sql.SET("amount_after_change = #{record.amountAfterChange,jdbcType=DECIMAL}");
        sql.SET("object_type = #{record.objectType,jdbcType=INTEGER}");
        sql.SET("object_id = #{record.objectId,jdbcType=BIGINT}");
        sql.SET("object_content = #{record.objectContent,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsRebateMerAccountRecordExample example = (BsRebateMerAccountRecordExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsRebateMerAccountRecord record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_rebate_mer_account_record");
        
        if (record.getAccountId() != null) {
            sql.SET("account_id = #{accountId,jdbcType=BIGINT}");
        }
        
        if (record.getAccountNumber() != null) {
            sql.SET("account_number = #{accountNumber,jdbcType=BIGINT}");
        }
        
        if (record.getTradeType() != null) {
            sql.SET("trade_type = #{tradeType,jdbcType=INTEGER}");
        }
        
        if (record.getTradeNumber() != null) {
            sql.SET("trade_number = #{tradeNumber,jdbcType=VARCHAR}");
        }
        
        if (record.getTradeAmount() != null) {
            sql.SET("trade_amount = #{tradeAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getAmountBeforeChange() != null) {
            sql.SET("amount_before_change = #{amountBeforeChange,jdbcType=DECIMAL}");
        }
        
        if (record.getAmountAfterChange() != null) {
            sql.SET("amount_after_change = #{amountAfterChange,jdbcType=DECIMAL}");
        }
        
        if (record.getObjectType() != null) {
            sql.SET("object_type = #{objectType,jdbcType=INTEGER}");
        }
        
        if (record.getObjectId() != null) {
            sql.SET("object_id = #{objectId,jdbcType=BIGINT}");
        }
        
        if (record.getObjectContent() != null) {
            sql.SET("object_content = #{objectContent,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsRebateMerAccountRecordExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}